
#define SAA7124_ADR (0x88)

int SAA7124_check(void *private) { // 0001.6834
	return I2CReadDevice(private,SAA7124_ADR,0x00)==-1;
}

int SAA7124_shadow[256];

int SAA7124_setreg(void *private,int reg,int val) { // 0001.6860
	SAA7124_shadow[reg]=val;
	return I2CWriteDevice(private,SAA7124_ADR,reg,val);
}

int SAA7124_getreg(void *private,int reg) { // 0001.6898
	return I2CReadDevice(private,SAA7124_ADR,reg);
}

int SAA7124_getshadowreg(void *private,int reg) { 
	return SAA7124_shadow[reg];
}

int SAA7124_disable(void *private) { // 0001.6824
	return SAA7124_setreg(private,0x11,0x00);
}

int SAA7124_testpattern(void *private) { // 0001.74f4
	return SAA7124_setreg(private,0x3a,0x83);	// ELSA uses 0xab, which is B/W ...
}

void SAA7124_setup(void *private) {

	SAA7124_setreg(private,0x00,0x00);	/* nonsense IMHO */

	SAA7124_setreg(private,0x3a,0x03);	/* normal Operation 0x23 ??? */

	SAA7124_setreg(private,0x5a,0x77);	/* Carrier Phase shift */

	SAA7124_setreg(private,0x5b,0x7d);	/* Verstaerkung Cb */
	SAA7124_setreg(private,0x5c,0xaf);	/* Verstaerkung Cr */

	SAA7124_setreg(private,0x5d,0x3c);
	SAA7124_setreg(private,0x5e,0x3f);
	SAA7124_setreg(private,0x5f,0x3f);

	SAA7124_setreg(private,0x61,0x02);

	SAA7124_setreg(private,0x62,0x4b);

	SAA7124_setreg(private,0x63,0xcb);
	SAA7124_setreg(private,0x64,0x8a);
	SAA7124_setreg(private,0x65,0x09);
	SAA7124_setreg(private,0x66,0x2a);

	SAA7124_setreg(private,0x67,0x55); /* 'U' captioning data - surplus */
	SAA7124_setreg(private,0x68,0x56); /* 'V' */
	SAA7124_setreg(private,0x69,0x67); /* 'g' */
	SAA7124_setreg(private,0x6a,0x58); /* 'X' */

	SAA7124_setreg(private,0x6c,0x03);
	SAA7124_setreg(private,0x6d,0x30);

	SAA7124_setreg(private,0x6f,0x00);	/* No captioning */

	SAA7124_setreg(private,0x7d,0x00);	/* ???? */

	SAA7124_setreg(private,0x6b,0x20);	/* Sync from trcv2 */
	SAA7124_setreg(private,0x6e,0x20);

	SAA7124_setreg(private,0x70,0x80);
	SAA7124_setreg(private,0x70,0xe8);
	SAA7124_setreg(private,0x70,0x10);

	SAA7124_setreg(private,0x7A,35);	/* First active line*/
	SAA7124_setreg(private,0x7B,(256+40)&0xff)	/* Last active line */;
	SAA7124_setreg(private,0x7C,0x40);	/* Overflow */

}

